SystemOrganization addCategory: #CopyHierarchy!

!ClassDescription methodsFor: '*CopyHierarchy' stamp: 'hjo 4/20/2012 10:18'!
definitionWithSuperclass
	"Answer a String that defines the receiver."

	| aStream |
	aStream := (String new: 800) writeStream.
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	(self hasTraitComposition and: [self traitComposition notEmpty]) ifTrue: [
		aStream cr; tab; nextPutAll: 'uses: ';
			nextPutAll: self traitCompositionString].
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: self category asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !

Object subclass: #CopyHierarchy
	instanceVariableNames: 'classNamePrefix classCategoryForDupedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CopyHierarchy'!

!CopyHierarchy classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/20/2012 12:20'!
classCategoryForExamples

	^'CopyHierarchyExampleResult'! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:23'!
copySubclassesOfCollection

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X10';
		runWithSubclasses: Collection.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:24'!
copySubclassesOfGradientFillStyle

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X20';
		runWithSubclasses: GradientFillStyle.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:24'!
copySubclassesOfLineSegment

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X30';
		runWithSubclasses: LineSegment.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfArray

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X40';
		runWithSuperclasses: Array.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfCollection

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X50';
		runWithSuperclasses: Collection.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfNil

	"This is invalid request. Should not do anything."
	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X60';
		runWithSuperclasses: nil.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:19'!
copySuperclassesOfObject

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X70';
		runWithSuperclasses: Object.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:19'!
copySuperclassesOfProtoObject

	"This is invalid request. Should not do anything."
	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'x80';
		runWithSuperclasses: ProtoObject.! !

!CopyHierarchy classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/20/2012 12:08'!
runAllExample

	(self class methodsInCategory: 'example') do: [:sel|
		self perform: sel ].! !

!CopyHierarchy methodsFor: 'private' stamp: 'hjo 7/20/2012 11:08'!
changeSuperclassAfterDupClass: aClass

	|dup|
	dup := self dupClass: aClass.
	dup superclass name = (self nameOfDupOfClass: aClass superclass) ifTrue: [^self].
	self moveClassNamed: dup name toSuper: (self nameOfDupOfClass: aClass superclass).! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:09'!
classCategoryForDupedClass: aString 

	classCategoryForDupedClass := aString! !

!CopyHierarchy methodsFor: 'testing' stamp: 'hjo 7/20/2012 11:09'!
classExistsByName: aSymbol

	^[Smalltalk at: aSymbol. true] on: KeyNotFound do: [:exp| false ].! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:09'!
classNamePrefix: aString 

	classNamePrefix := aString ! !

!CopyHierarchy methodsFor: 'private' stamp: 'hjo 7/20/2012 11:10'!
dupClass: aClass

	| dupName dup |
	dupName := self nameOfDupOfClass: aClass.
	(self classExistsByName: dupName) ifTrue: [ ^Smalltalk at: dupName ].
	dup := aClass duplicateClassWithNewName: dupName.
	dup category: classCategoryForDupedClass.
	^dup
	

	 ! !

!CopyHierarchy methodsFor: 'private' stamp: 'hjo 7/20/2012 11:10'!
moveClassNamed: classSymbol toSuper: superClassSymbol

	Compiler evaluate: (superClassSymbol ,  (Smalltalk at: classSymbol) definitionWithSuperclass).! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:10'!
nameOfDupOfClass: aClass

	^(classNamePrefix, aClass name) asSymbol! !

!CopyHierarchy methodsFor: 'undo' stamp: 'hjo 7/20/2012 11:11'!
removeCategoryOfDupes

	self class environment organization removeSystemCategory: classCategoryForDupedClass.! !

!CopyHierarchy methodsFor: 'public operation' stamp: 'hjo 7/20/2012 11:16'!
runWithSubclasses: aClass

	self dupClass: aClass.
	aClass allSubclassesDo: [:each| self changeSuperclassAfterDupClass: each ].! !

!CopyHierarchy methodsFor: 'public operation' stamp: 'hjo 7/20/2012 11:27'!
runWithSuperclasses: aClass

	aClass = nil ifTrue: [^self].
	aClass superclass = nil ifTrue: [ ^self "^self dupClass: aClass" ].
	self runWithSuperclasses: (aClass superclass).
	self changeSuperclassAfterDupClass: aClass.! !
